#!/usr/local/bin/php -q
<?php
// set your Jabber server hostname, username, and password here..  Constants
define("JABBER_SERVER","asterisk.itp.tsoa.nyu.edu");
define("JABBER_USERNAME","webuser");
define("JABBER_PASSWORD","webuser");
define("CHATROOM","test@test.asterisk.itp.tsoa.nyu.edu");
define("TOUSER","admin@asterisk.itp.tsoa.nyu.edu");

define("DEBUG",false); // Show debug messages
define("RUN_TIME",3);  // set a maximum run time of 30 seconds
define("CBK_FREQ",1);   // fire a callback event every second

$uniqueid = "";
if (!isset($_GET['uniqueid']))
{
	echo "Sorry, you must have a client id set\n";
// for Debuggong command line
	$uniqueid = "mynick";
//	exit();
}
else
{
	$uniqueid = $_GET['uniqueid'];
}

// include the Jabber class
require_once("class_Jabber.php");

// create an instance of the Jabber class
$display_debug_info = false;
$jab = new Jabber($display_debug_info);

// set handlers for the events we wish to be notified about
$jab->set_handler_function("connected","handleConnected");
$jab->set_handler_function("authenticated","handleAuthenticated");
$jab->set_handler_function("authfailure","handleAuthFailure");
$jab->set_handler_function("heartbeat","handleHeartbeat");
$jab->set_handler_function("error","handleError");

$jab->set_handler_function("message_normal","handleMessage");
$jab->set_handler_function("message_chat","handleMessage");
$jab->set_handler_function("message_groupchat","handleMessage");
$jab->set_handler_function("message_headline","handleMessage");

$jab->set_handler_function("debug_log","handleDebug");
$jab->set_handler_function("rosterupdate","handleRosterUpdate");

if (DEBUG)
{
	echo "Connecting ...\n";
}

// connect to the Jabber server
if (!$jab->connect(JABBER_SERVER)) {
	die("Could not connect to the Jabber server!\n");
}

// now, tell the Jabber class to begin its execution loop
$jab->execute(CBK_FREQ,RUN_TIME);

// Note that we will not reach this point (and the execute() method will not
// return) until $jab->terminated is set to TRUE.  The execute() method simply
// loops, processing data from (and to) the Jabber server, and firing events
//
// This event-based model will be familiar to programmers who have worked on
// desktop applications, particularly in Win32 environments.

// disconnect from the Jabber server
//$jab->terminated = true;
$jab->disconnect();


// called when a connection to the Jabber server is established
function handleConnected() {
	GLOBAL $jab;

	if (DEBUG)
	{
		echo "Connected!\n";
	}
		
	// now that we're connected, tell the Jabber class to login
	if (DEBUG)
	{
		echo "Authenticating ...\n";
	}
	$jab->login(JABBER_USERNAME,JABBER_PASSWORD);
}
	
// called after a login to indicate the the login was successful
function handleAuthenticated() {
	GLOBAL $jab, $uniqueid;
	if (DEBUG)
	{
		echo "Authenticated!\n";
	}

	// Tell the server that we are available.
	$jab->set_presence("","Ya, I'm online... so what?");

	// Join the chatroom use our uniqueid as our nick
	//$jab->send_presence("",CHATROOM . "/" . $uniqueid,null,null,null,true);

	// If we submitted a message, send it to the chat room
	if (isset($_GET['message']))
	{
		// Sending a message to a chat room
		//$jab->message(CHATROOM,"groupchat",NULL,$_GET['message']);

		// Send a message to a specific user
        	$jab->message(TOUSER,"chat",NULL,$_GET['message']);
	}
}
	
// called after a login to indicate that the login was NOT successful
function handleAuthFailure($code,$error) {
	GLOBAL $jab;
	echo "Authentication failure: $error ($code)\n";
		
	// set terminated to TRUE in the Jabber class to tell it to exit
	$jab->terminated = true;
}
	
// called periodically by the Jabber class to allow us to do our own
// processing
function handleHeartbeat() {
	GLOBAL $jab;
	if (DEBUG)
	{
		//echo "Waiting for incoming message ...\n";
	}
}
	
// called when an error is received from the Jabber server
function handleError($code,$error,$xmlns) {
	GLOBAL $jab;
	echo "Error: $error ($code)".($xmlns?" in $xmlns":"")."\n";
	if (is_array($error))
	{
		print_r($error);
	}
}
	
// called when a message is received from a remote contact
function handleMessage($from,$to="",$body="",$subject="",$thread="",$id="",$extended="") {
	GLOBAL $jab;
	if (DEBUG)
	{
		echo "Incoming message!\n";

		echo "From: $from\t\tTo: $to\n";
		echo "Subject: $subject\tThread; $thread\n";
		echo "Body: $body\n";
		echo "ID: $id\n";
		//var_dump($extended);
		echo "\n";
	}
	
	$fromuserlist = split('@',$from);

	echo  $fromuserlist[0] . ": " . $body . "<br />\n";
		
	//$jab->message("test@test.asterisk.itp.tsoa.nyu.edu","groupchat",NULL,"Hi");
	//$jab->message($from,"chat",NULL,"Hello! You said: ".$body);
}
	
function _contact_info($contact) {
	GLOBAL $jab;
	return sprintf("Contact %s (JID %s) has status %s and message %s\n",$contact['name'],$contact['jid'],$contact['show'],$contact['status']);
}
	
function handleRosterUpdate($jid) {
	GLOBAL $jab;
	// the first roster update indicates that the entire roster has been
	// downloaded for the first time
	if (DEBUG)
	{
		echo "Roster downloaded:\n";
		foreach ($jab->roster as $k=>$contact) {
			echo _contact_info($contact);
		}	
	}
}
	
function handleDebug($msg,$level) {
	GLOBAL $jab;
	if (DEBUG)
	{
		echo "DBG: $msg\n";
	}
}
?>
